\documentclass[a4paper,11pt]{article}
\usepackage[T1]{fontenc}
\usepackage[verbose,hypertexnames=false,bookmarksopenlevel=1,bookmarksopen,bookmarksnumbered,colorlinks,plainpages=false,linktocpage]{hyperref}
\usepackage[dvips]{graphicx}
\usepackage{url}
\usepackage{listings}

\def \DL {{\tt dadi}}

\lstset{language=C,basicstyle=\tiny}
\usepackage[normalem]{ulem}
\title{\DL, a configuration management framework}
\author{Frederik Deweerdt}
\date{March 2007}


\begin{document}
\maketitle

\section{\DL\ overview}
\DL\ stands for DAta DIspatcher, it's aim is to provide simple means to
access a data model described by an SNMPv2 MIB.  It takes the form of
a Ruby script that generates C, Perl or Javascript code, depending on
the choosen backend (the {\tt dumper}).

\section{\DL\ requirements}
The following software packages are required to be able to run the
\DL\ code generator. The recommended versions are the ones we have
witnessed working, please report if you had any success/problems with
other versions.
\begin{itemize}
\item{
	net-snmp
	\begin{itemize}
		\item{http://net-snmp.sourceforge.net/}
		\item{recommended version: = 5.3.1}
	\end{itemize}
}

\item{
	tsp
	\begin{itemize}
		\item{http://savannah.nongnu.org/projects/tsp}
		\item{recommended version: latest CVS}
		\item{untar tsp archive, cd into created dir}
		\item{type "cmake ."}
		\item{type make ; make install}
	\end{itemize}
}

\item{
	libsmi
	\begin{itemize}
		\item{http://www.ibr.cs.tu-bs.de/projects/libsmi/}
		\item{recommended version: >= 0.4.5}
	\end{itemize}
}
\item{
	ruby
	\begin{itemize}
		\item{http://www.ruby-lang.org/}
		\item{recommended version: >= 1.8.4}
	\end{itemize}
}
\item{
	ruby gems
	\begin{itemize}
		\item{http://www.rubygems.org/}
		\item{recommended version: >= 0.9.2}
	\end{itemize}
}\item{
	cstemplate
	\begin{itemize}
		\item{http://cstemplate.rubyforge.org/}
		\item{recommended version: = 0.5.1}
		\item{Note: using ruby gems 'gem install -r cstemplate' is a
		handy way to obtain cstemplate}
		\item{Note: some distributions may require an {\tt ln -s
/usr/lib/libruby.so.1.8 /usr/lib/libruby1.8.so.1.8} for the template to work}
	\end{itemize}
}

\end{itemize}

\section{Installing \DL}
\DL\ comes with an installation script {\tt install.sh} which takes a
destination directory as an argument.
\begin{verbatim}
# ./install.sh -d /opt/dadi
\end{verbatim}
The following tree structure is generated:
\begin{verbatim}
> tree /opt/dadi/
/opt/dadi/
|-- bb_dumper.rb
|-- dadi.rb
|-- dadienv
|-- data_tree.rb
|-- doc
|   `-- dadi.pdf
|-- example
|   |-- Makefile
|   `-- test.c
|-- node.rb
|-- smi_parser.rb
|-- src
|   |-- dadi.c
|   |-- dadi.h
|   |-- dadi_snmp.c
|   `-- dadi_snmp.h
`-- tmpl
    `-- bb.tmpl

4 directories, 14 files
\end{verbatim}
Two files and one directory are relevant for the end-user:
\begin{itemize}
\item{dadi.rb: the main generation script}
\item{dadienv: sets the needed environment variables}
\item{example: this directory contains a sample application, that shows how to
use the dadi environment}
\end{itemize}

\subsection{Compiling the sample code}
This section assumes that the following files:
\begin{itemize}
\item{SATLAB-DVB-RCS-MIB.xml}
\item{SNT-MAC-PRIVATE-MIB.xml}
\item{SNT-MAC-PUBLIC-MIB.xml}
\item{SNT-MNGT-MIB.xml}
\end{itemize}
...where generated from the original MIBs with {\tt smidump -f xml} and
are available in the {\tt ~/test/} directory. We will go through all the
needed actions to get a sample \DL\ project compiled.
The following steps are needed to compile the sample code bundled with the
MIB.
\begin{verbatim}
$ cd test

# Set the needed environment variables up
$ . /opt/dadi/dadienv

# Copy the sample files
$ cp /opt/dadi/example/* .

# Verify that the needed mib files are here
$ ls *.xml
SATLAB-DVB-RCS-MIB.xml  SNT-MAC-PRIVATE-MIB.xml
SNT-MAC-PUBLIC-MIB.xml  SNT-MNGT-MIB.xml

# Launch the build process
# This compiles mib.c dadi.c and dadi_snmp.c
# and generates a libmib.so shared library
$ make
/opt/dadi/dadi.rb -x SATLAB-DVB-RCS-MIB.xml \
		  -x SNT-MNGT-MIB.xml \
		  -x SNT-MAC-PUBLIC-MIB.xml \
		  -x SNT-MAC-PRIVATE-MIB.xml
gcc -g -shared -o libmib.so src/mib.c /opt/dadi//src/dadi.c
/opt/dadi//src/dadi_snmp.c  `net-snmp-config --libs`
-lnetsnmpagent  -lnetsnmphelpers `perl -MExtUtils::Embed -e ldopts`
-L/opt/tsp-0.8.3cvs/lib/  -I/opt/tsp-0.8.3cvs/include/ -I. -lbb
-Wl,-e,dadi_main -Iinclude/ -I/opt/dadi//src/
/usr/lib/gcc/i686-pc-linux-gnu/4.1.1/../../../../i686-pc-linux-gnu/bin/ld:
warning: creating a DT_TEXTREL in object.  gcc -g -o test test.c
-I/opt/tsp-0.8.3cvs/include/ -lbb  -L/opt/tsp-0.8.3cvs/lib/
-I/opt/dadi//src/ -I./include -L. -lmib
$
\end{verbatim}
At the end of the process, the {\tt libmib.so} and {\tt test} files have
been generated, and are available to test the \DL\ installation in your
environnement. Provided that you have the required access rights and
that you have a running snmp server, after launching the {\tt ./test}
program, you should be able to issue the following commands:
\begin{verbatim}
#Write SNMP
$ snmpset -v2c -c public localhost \
        1.3.6.1.4.1.637.56.4.55.12.1.1.1.1.2.1.0 i
123
SNMPv2-SMI::enterprises.637.56.4.55.12.1.1.1.1.2.1.0 = INTEGER: 123

#Query SNMP
$ snmpget -v2c -c public localhost \
        1.3.6.1.4.1.637.56.4.55.12.1.1.1.1.2.1.0
SNMPv2-SMI::enterprises.637.56.4.55.12.1.1.1.1.2.1.0 = INTEGER: 123

#Query TSP blackboard
$ /opt/tsp-0.8.3cvs/bin/bb_tools read snt_mac_public_mib \
        snt_mac_public_mib.sntMacActionResetCounters
123

# Write a table in the TSP blackboard
$ /opt/tsp-0.8.3cvs/bin/bb_tools write snt_mac_public_mib \
        snt_mac_public_mib.sntMacActionTable[0].sntMacActionResetCounters 321

# Write TSP blackboard
$ /opt/tsp-0.8.3cvs/bin/bb_tools write snt_mac_public_mib \
        snt_mac_public_mib.sntMacActionResetCounters 321

#Query SNMP
$ snmpget -v2c -c public localhost \
        1.3.6.1.4.1.637.56.4.55.12.1.1.1.1.2.1.0
SNMPv2-SMI::enterprises.637.56.4.55.12.1.1.1.1.2.1.0 = INTEGER: 321
\end{verbatim}

\section{Using \DL}
\subsection{The code generation}
Code generation is handled by the {\tt dadi.rb} script. It accepts the
following options:
\begin{verbatim}
Usage: dadi.rb [options]
    -x, --xml-file=FILE              XML file to parse (REQUIRED)
    -p, --source-prefix=PREFIX       Add a prefix to the generated C files
    -d, --dest=DEST                  Destination directory
    -h, --help                       Show this message
\end{verbatim}
The {\tt -x} option must at least be passed once, and it can be passed
multiple times to handle multiple MIBs.
The following example show how to invoke {\tt dadi.rb} to parse two MIBs:
\begin{verbatim}
# dadi.rb -x MIB1.xml -x MIB2.xml -d .
\end{verbatim}
In the above example, the {\tt -d} option is passed, it instructs {\tt
dadi.rb} to output the generated files in the {\tt .} directory.

The typical result from such a command line is the following:
\begin{verbatim}
# ls src/
mib.c
# ls include/
enums.h  inlines_mib.h
\end{verbatim}
Let's review the function of each file:
\begin{itemize}
\item{enums.h: contains the MIB's enumerated values}
\item{inlines\_mib.h: contains the setters and getters for all the MIB members,
see next section}
\item{mib.c: main code of the lib, this is only internal code, and shouldn't
be of any interest to the user}
\end{itemize}
\subsection{Getters and setters}
For each leaf object of the MIB, C setter and getter functions are provided.
There will be four kinds of accessor functions generated:
\begin{itemize}
\item{Bare accessors, that directly access to the memory}
\item{Locked accessors, that lock the black board before accessing to the memory (WIP)}
\item{Triggering accessors, that inform the different users that the memory is
about to be accessed (WIP)}
\item{Locked/triggering accessors a combination of the two above (WIP)}
\end{itemize}
As an example, the {\tt sntMacPrivateConfigMyFoo} OBJECT-IDENTITY defined in
a {\tt SNT-MAC-PRIVATE-MIB.txt}, will generate the following accessors:
\begin{verbatim}
/* in file inlines_mib.h */
static inline Unsigned32 get_sntMacPrivateStatusMyFoo() {
        [...]
}
static inline int set_sntMacPrivateStatusMyFoo(Unsigned32 v) {
        [...]
}
\end{verbatim}

\subsection{The C structures}
This section as only an informative status, we strongly discourage
accessing the data through bare pointers, you have been warned :).
The MIB is mapped to C structures as the following figure shows:
\begin{verbatim}

	----    MIB file    ----

	sntMacPrivate OBJECT-IDENTITY
	  STATUS current
	  DESCRIPTION "Private MIB for MACC"

	sntMacPrivateConfig OBJECT-IDENTITY
	  STATUS current
	  DESCRIPTION "MAC private config
	               MMD_APP_MODULE MACC MMD_APP_MODULE_END"
	  ::= { sntMacPrivate 1 }

	sntMacPrivateConfigMyFoo OBJECT-TYPE
	  SYNTAX  Unsigned32
	  MAX-ACCESS read-write
	  STATUS current
	  DESCRIPTION "My foo object"
	  ::= { sntMacPrivateConfig 1 }


        /* Corresponding mib.h file */
        struct sntMacPrivateConfig_S {
                 uint32_t sntMacPrivateConfigMyFoo;
        }
        struct sntMacPrivate_S {
                struct sntMacPrivateConfig_S sntMacPrivateConfig;
        }

        struct sntMacPrivate_S *sntMacPrivate;
\end{verbatim}
The {\tt sntMacPrivate} pointer is the allocated in shared memory and
available to all the users of the data model. The next section explain how
sharing works.
\subsection{Tables in DADI}
The way tables are used in DADI mimics the way they are handled by SNMP, rows
are always present but the RowStatus member of the array indicates the state.
Let us examine the {\tt rcstConfigFwdLinkStartConfigTable\_S} table. It is
structured as follows:
\begin{verbatim}
struct rcstConfigFwdLinkStartConfigTable_S {
        Integer32 rcstConfigFwdLinkStartConfigPopId;
        Integer32 rcstConfigFwdLinkStartConfigFreq;
        int rcstConfigFwdLinkStartConfigPolar;
        int rcstConfigFwdLinkStartConfigStandard;
        int rcstConfigFwdLinkStartConfigModulation;
        int rcstConfigFwdLinkStartConfigRollOff;
        Integer32 rcstConfigFwdLinkStartConfigSymbRate;
        int rcstConfigFwdLinkStartConfigInnerFec;
        int rcstConfigFwdLinkStartConfigRowStatus;
};
\end{verbatim}
The {\tt rcstConfigFwdLinkStartConfigRowStatus} values are described by
the following enum:
\begin{verbatim}
enum rcstConfigFwdLinkStartConfigRowStatus {
        rcstConfigFwdLinkStartConfigRowStatus_active = 1,
        rcstConfigFwdLinkStartConfigRowStatus_notInService = 2,
        rcstConfigFwdLinkStartConfigRowStatus_notReady = 3,
        rcstConfigFwdLinkStartConfigRowStatus_createAndGo = 4,
        rcstConfigFwdLinkStartConfigRowStatus_createAndWait = 5,
        rcstConfigFwdLinkStartConfigRowStatus_destroy = 6,
};
\end{verbatim}
The {\tt rcstConfigFwdLinkStartConfigRowStatus} value
will thus reflect the value of a given row \footnote{see
http://www.shrubbery.net/mibs/SNMPv2-TC.txt, search for the first
occurence of "RowStatus"}.
The following code will be used to determine the number of active rows
in the {\tt rcstConfigFwdLinkStartConfigTable}
\begin{verbatim}
int active_rows() {
        int i;
        int active = 0;

        for (i=0; i < get_rcstConfigFwdLinkStartConfigTableSize(); i++) {
                if (get_rcstConfigFwdLinkStartConfigRowStatus(i)
                    == rcstConfigFwdLinkStartConfigRowStatus_active) {
                        active++;
                }
        }
        return active;
}
\end{verbatim}


\section{DADI events}
The DADI generated libraries allow the customers to be warned whenever a
variable they are interested in is changed. This is done through DADI API
calls. There are two main functions that set up the DADI API, namely:
\begin{itemize}
\item{dadi\_first\_init: a callback is passed to that function, it will be
called each time a variable is changed through SNMP.}
\item{dadi\_mainloop: called once the setup is done by the application. This
call is blocking and starts the SNMP AgentX up.}
\end{itemize}
\subsection{Quick example}
The following short example shows how to use both functions above.
\begin{verbatim}
#include "dadi.h"
#include "enums.h"

/**
@brief Called by the DADI framework

@param type  identifier of the variable being changed
@param data  if GETtin, always NULL
             if SETtin, the new value
@param size  the size of @data


@return  The callback must return:
                - '0' if it wishes to refuse the new data
                - '1' if it wishes to accept the new data
*/
int test_callback(int var, enum dadi_event_type evt)
{
        if (var == cstSystemInstallationLocation_id && evt == DADI_EVENT_TYPE_SET) {
                printf("System Installation Location ID changed\n");
                return 1;
        }
        if (evt == DADI_EVENT_TYPE_GET) {
                printf("Get done : %d\n", var);
        } else {
                printf("Set done : %d %d\n", var);
        }
        return 1;
}

int main()
{
        dadi_first_init(test_callback);
        dadi_mainloop();

        return 0;
}
\end{verbatim}
\section{The sharing framework}
%% FIXME: WIP
\DL\ uses a TSP Blackboard \footnote{see
http://savannah.nongnu.org/projects/tsp for documentation.} to share the
memory accross different users. System V IPCs are used for message passing,
memory sharing and locking.
Warning: System V IPCs are permanent. That is, a faulty exit of your
program won't free the necessary structures.

\section{Miscellaneous tips}
There are several files included in the \DL\ package that might help you.
\begin{itemize}
\item{To install an SNMP agent, you need to add the following lines to your
{\tt snmpd.conf} file:
\begin{verbatim}
agentaddress 161
master agentx
\end{verbatim}
}
\item{example/Makefile: This sample Makefile contains a whole build process, either
for the library itself, or for a test program ({\tt test.c})}
\item{example/test.c: A sample user that does nothing but writes to the {\tt
sntMacPrivateObjects.sntMacPrivate.sntMacPrivateAction.sntMacPrivateActionMyFoo}
variable. You can use the following command to read its value {\tt bb\_tools
bb\_read snt\_mac\_private\_mib
snt\_mac\_private\_mib.sntMacPrivateActionMyFoo}.}
\end{itemize}

\end{document} 
